/*******************************************************************************
 * Copyright (c) 2009, 2013 Oracle and/or its affiliates. All rights reserved.
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License v1.0 and Eclipse Distribution License v. 1.0
 * which accompanies this distribution.
 * The Eclipse Public License is available at http://www.eclipse.org/legal/epl-v10.html
 * and the Eclipse Distribution License is available at
 * http://www.eclipse.org/org/documents/edl-v10.php.
 *
 * Contributors:
 *     Oracle - initial API and implementation
 ******************************************************************************/
package org.eclipse.persistence.tools.db.driver;

/**
 * Catalog strategy for DTP database drivers that do not have catalogs (e.g. MySQL; see bug 249013).
 *
 * @version 2.6
 */
class NoCatalogStrategy implements CatalogStrategy {

	NoCatalogStrategy() {
		super();
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public boolean supportsCatalogs() {
		return false;
	}
}